const toString = Object.prototype.toString;
export function is(val, type) {
    return toString.call(val) === `[object ${type}]`;
}
export function isFunction(val) {
    return is(val, 'Function');
}
export function isArray(val) {
    return val && Array.isArray(val);
}
export function isRegExp(val) {
    return is(val, 'RegExp');
}
export function sleep(time) {
    return new Promise((resolve) => {
        setTimeout(() => {
            resolve();
        }, time);
    });
}
export function param2Obj(url) {
    const search = url.split('?')[1];
    if (!search) {
        return {};
    }
    return JSON.parse('{"' +
        decodeURIComponent(search)
            .replace(/"/g, '\\"')
            .replace(/&/g, '","')
            .replace(/=/g, '":"')
            .replace(/\+/g, ' ') +
        '"}');
}
export function parseData(ctx) {
    return new Promise((resolve, reject) => {
        try {
            let str = '';
            ctx.req.on('data', (data) => {
                str += data;
            });
            ctx.req.addListener('end', () => {
                resolve(parseUrl(str));
            });
        }
        catch (err) {
            reject(err);
        }
    });
}
function parseUrl(url) {
    let obj = {};
    let arr = url.split('&');
    arr.forEach((e, i) => {
        let temparr = e.split('=');
        obj[temparr[0]] = temparr[1];
    });
    return obj;
}
